/*
    Copyright (c) 2011 digitalSTROM.org, Zurich, Switzerland

    Author: Patrick Staehlin, futureLAB AG <pstaehlin@futurelab.ch>

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

// JSON parser start ----------------------------------------------------------
//
// Below is the minified JSON parser from http://json.org/json2.js
// 2010-08-25, Public Domain 
// NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.
if(!this.JSON){this.JSON={};}
(function(){function f(n){return n<10?'0'+n:n;}
if(typeof Date.prototype.toJSON!=='function'){Date.prototype.toJSON=function(key){return isFinite(this.valueOf())?this.getUTCFullYear()+'-'+
f(this.getUTCMonth()+1)+'-'+
f(this.getUTCDate())+'T'+
f(this.getUTCHours())+':'+
f(this.getUTCMinutes())+':'+
f(this.getUTCSeconds())+'Z':null;};String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(key){return this.valueOf();};}
var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta={'\b':'\\b','\t':'\\t','\n':'\\n','\f':'\\f','\r':'\\r','"':'\\"','\\':'\\\\'},rep;function quote(string){escapable.lastIndex=0;return escapable.test(string)?'"'+string.replace(escapable,function(a){var c=meta[a];return typeof c==='string'?c:'\\u'+('0000'+a.charCodeAt(0).toString(16)).slice(-4);})+'"':'"'+string+'"';}
function str(key,holder){var i,k,v,length,mind=gap,partial,value=holder[key];if(value&&typeof value==='object'&&typeof value.toJSON==='function'){value=value.toJSON(key);}
if(typeof rep==='function'){value=rep.call(holder,key,value);}
switch(typeof value){case'string':return quote(value);case'number':return isFinite(value)?String(value):'null';case'boolean':case'null':return String(value);case'object':if(!value){return'null';}
gap+=indent;partial=[];if(Object.prototype.toString.apply(value)==='[object Array]'){length=value.length;for(i=0;i<length;i+=1){partial[i]=str(i,value)||'null';}
v=partial.length===0?'[]':gap?'[\n'+gap+
partial.join(',\n'+gap)+'\n'+
mind+']':'['+partial.join(',')+']';gap=mind;return v;}
if(rep&&typeof rep==='object'){length=rep.length;for(i=0;i<length;i+=1){k=rep[i];if(typeof k==='string'){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}else{for(k in value){if(Object.hasOwnProperty.call(value,k)){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}
v=partial.length===0?'{}':gap?'{\n'+gap+partial.join(',\n'+gap)+'\n'+
mind+'}':'{'+partial.join(',')+'}';gap=mind;return v;}}
if(typeof JSON.stringify!=='function'){JSON.stringify=function(value,replacer,space){var i;gap='';indent='';if(typeof space==='number'){for(i=0;i<space;i+=1){indent+=' ';}}else if(typeof space==='string'){indent=space;}
rep=replacer;if(replacer&&typeof replacer!=='function'&&(typeof replacer!=='object'||typeof replacer.length!=='number')){throw new Error('JSON.stringify');}
return str('',{'':value});};}
if(typeof JSON.parse!=='function'){JSON.parse=function(text,reviver){var j;function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==='object'){for(k in value){if(Object.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!==undefined){value[k]=v;}else{delete value[k];}}}}
return reviver.call(holder,key,value);}
text=String(text);cx.lastIndex=0;if(cx.test(text)){text=text.replace(cx,function(a){return'\\u'+
('0000'+a.charCodeAt(0).toString(16)).slice(-4);});}
if(/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,'@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,']').replace(/(?:^|:|,)(?:\s*\[)+/g,''))){j=eval('('+text+')');return typeof reviver==='function'?walk({'':j},''):j;}
throw new SyntaxError('JSON.parse');};}}());
// JSON parser end ------------------------------------------------------------

var LOGFILE_NAME = "google-meter.log";
var l = new Logger(LOGFILE_NAME);




if (raisedEvent.name === "running") 
{
    l.logln("running");
    
    Property.load();
    
    // start sending out metering data
    var event = new TimedEvent("google-meter.sendMeterData", '+20');
    //store new queueID
    Property.setProperty('queueID', event.raise());
    
    //set new version number
    Property.setProperty('version', '0.1.0');
    Property.setFlag('version', 'ARCHIVE', true);
    Property.store();
}
else if (raisedEvent.name === "google-meter.updateRegistration") 
{
    l.logln('updateRegistration');
    
    if (raisedEvent.parameter.params != undefined) 
    {
        Property.setProperty("params", raisedEvent.parameter.params);
        Property.setFlag("params", "ARCHIVE", true);
        Property.store();
        
        // start sending out metering data
        var event = new TimedEvent("google-meter.sendMeterData", '+10');
        //store new queueID
        Property.setProperty('queueID', event.raise());
    }
    
}
else if (raisedEvent.name === "google-meter.sendMeterData") 
{
    //delete old event from queue. it is not cleaned up automatically, because script stays in memory
    var queueID = Property.getProperty('queueID');
    if (queueID != undefined && queueID != '') 
    {
        var queueNode = Property.getNode('/system/EventInterpreter/ScheduledEvents');
        queueNode.removeChild(queueID);
        
        // requeue request in 10 minutes
        var event = new TimedEvent("google-meter.sendMeterData", '+600');
        //store new queueID
        Property.setProperty('queueID', event.raise());
        
        
        function addLeadingZeroes(number, count)
        {
            var result = number + '';
            while (result.length < count) 
            {
                result = '0' + result;
            }
            return result;
        }
        
        function getRFCDate()
        {
            var d = new Date();
            var result = d.getUTCFullYear();
            result += '-' + addLeadingZeroes(d.getUTCMonth() + 1, 2);
            result += '-' + addLeadingZeroes(d.getUTCDate(), 2) + 'T';
            result += addLeadingZeroes(d.getUTCHours(), 2);
            result += ':' + addLeadingZeroes(d.getUTCMinutes(), 2);
            result += ':' + addLeadingZeroes(d.getUTCSeconds(), 2);
            result += '.000Z';
            return result;
        }
        
        function createFullPOSTString(path, token, meterValueString)
        {
            var result = 'POST /powermeter/feeds/event HTTP/1.0\r\n';
            result += 'Connection: close\r\n';
            result += 'Host: www.google.com\r\n';
            result += 'Authorization: AuthSub token="' + token + '"\r\n';
            result += 'Content-Type: application/atom+xml\r\n';
            
            var content = '<?xml version="1.0" encoding="UTF-8"?>\r\n';
            content += '<feed xmlns="http://www.w3.org/2005/Atom" xmlns:meter="http://schemas.google.com/meter/2008" xmlns:batch="http://schemas.google.com/gdata/batch">\r\n';
            content += meterValueString;
            content += '</feed>';
            
            result += 'Content-Length: ';
            result += content.length;
            result += '\r\n\r\n';
            result += content + '\r\n';
            
            return result;
        }
        
        function createMeterValueString(meterValue, id, path)
        {
            var content = '<entry>\r\n';
            content += '<category scheme="http://schemas.google.com/g/2005#kind" term="http://schemas.google.com/meter/2008#instMeasurement"/>\r\n';
            content += '<meter:subject> https://www.google.com/powermeter/feeds' + path + '.c' + id + '</meter:subject>\r\n';
            content += '<batch:id>' + id + '</batch:id>\r\n';
            content += '  <meter:occurTime meter:uncertainty="1.0">';
            content += getRFCDate();
            content += '</meter:occurTime>\r\n';
            content += '  <meter:quantity meter:uncertainty="0.001"';
            content += ' meter:unit="kW h">' + meterValue + '</meter:quantity>\r\n';
            content += '</entry>\r\n';
            
            return content;
        }
        
        var params = Property.getProperty("params");
        var token = JSON.parse(params).token;
        var path = JSON.parse(params).path;
        
        if ((token == null) || (path == null) || (token === "") || (path === "")) 
        {
            l.logln('Not sending anything, information incomplete');
        }
        else 
        {
        
            var socket = new TcpSocket();
            
            function onConnect(state, postString)
            {
                if (state) 
                {
                    l.logln("Connected");
                    socket.send(postString, function(bytesSent)
                    {
                        socket.close();
                    });
                }
                else 
                {
                    l.logln("Connection failed");
                }
            }
            
            var postString = createMeterValueString(Apartment.getEnergyMeterValue() / 1000, 1, path);
            
            var dsids = JSON.parse(JSON.parse(params).dsids);
            for (var k = 0; k < dsids.length; k++) 
            {
                postString += createMeterValueString(Apartment.getDSMeterByDSID(dsids[k]).getEnergyMeterValue() / 1000, k + 2, path)
            }
            
            socket.connect('www.google.com', 80, function(state)
            {
                onConnect(state, createFullPOSTString(path, token, postString));
            });
        }
    }
}
